// SampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sample.h"
#include "SampleDlg.h"

#include "AntAPI.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSampleDlg dialog

CSampleDlg::CSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSampleDlg)
	DDX_Control(pDX, IDC_LIST1, m_list);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CSampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSampleDlg message handlers

BOOL CSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSampleDlg::OnButton1() 
{
	IAntAPIObj AntObj;

	if (!AntObj.CreateDispatch(_T("NetAnts.API"))) return;

	//	AddUrl : Add one job to NetAnts
	//	bstrUrl : Url to be added
	//	bstrInfo : Job comment
	//	bstrReferer : HTTP Referer of this job
	AntObj.AddUrl(_T("http://www.netants.com/netants.exe"), 
		_T("NetAnts 1.0"), _T("http://www.netants.com"));
}

void CSampleDlg::OnButton2() 
{
	IAntAPIObj AntObj;

	if (!AntObj.CreateDispatch(_T("NetAnts.API"))) return;

	//	IsUrlExist : Check if Url has been exist
	//	bstrUrl : Url to be checked

	if (AntObj.IsUrlExist(_T("http://www.netants.com/netants.exe")))
		AfxMessageBox(_T("Url Exist!"));
	else
		AfxMessageBox(_T("Url not Exist!"));
}

void CSampleDlg::OnButton3() 
{
	IAntAPIObj AntObj;

	if (!AntObj.CreateDispatch(_T("NetAnts.API"))) return;

	//	AddUrlList : Add many jobs to NetAnts
	//	pList : Url-Comment array and HTTP referer(Referer, Url, Comment, Url, Comment...)

	SAFEARRAYBOUND rgsabound[1];    
	rgsabound[0].lLbound = 0;
    rgsabound[0].cElements =5;
	SAFEARRAY * psa = SafeArrayCreate(VT_VARIANT, 1, rgsabound);
	if (psa == NULL) return;

	LONG ix;
	COleVariant var;

	ix = 0;
	var.SetString(_T("http://www.netants.com"), VT_BSTR);
	SafeArrayPutElement(psa, &ix, &var);

	ix = 1;
	var.SetString(_T("http://www.netants.com/netants.exe"), VT_BSTR);
	SafeArrayPutElement(psa, &ix, &var);

	ix = 2;
	var.SetString(_T("NetAnts 1.0"), VT_BSTR);
	SafeArrayPutElement(psa, &ix, &var);

	ix = 3;
	var.SetString(_T("http://www.netants.com/addon_sample.exe"), VT_BSTR);
	SafeArrayPutElement(psa, &ix, &var);

	ix = 4;
	var.SetString(_T("NetAnts 1.0 AddOn Sample"), VT_BSTR);
	SafeArrayPutElement(psa, &ix, &var);

	VARIANT vList;
	vList.vt = VT_ARRAY;
	vList.pparray = &psa;

	AntObj.AddUrlList(&vList);

	SafeArrayDestroy(psa);
}

void CSampleDlg::OnButton4() 
{
	HSZ	hszService, hszTopic, hszItem;
	HCONV hConv = NULL;
	DWORD ddeInst = ((CSampleApp *)AfxGetApp())->m_ddeInst;

	hszService = DdeCreateStringHandle(ddeInst, _T("NetAnts"), 0);
	hszTopic = DdeCreateStringHandle(ddeInst, _T("WWW_OPENURL"), 0);

	hConv = DdeConnect(ddeInst, hszService, hszTopic, NULL);
	if (hConv != NULL) 
	{
		//	LinkItem = "Url to be added,Save as directory"
		hszItem = DdeCreateStringHandle(ddeInst, 
			_T("http://www.netants.com/netants.exe,c:\\"), 0);	
		
		DdeClientTransaction(NULL, 0, hConv, hszItem, CF_TEXT, XTYP_REQUEST, 500, NULL);

		DdeDisconnect(hConv);
		DdeFreeStringHandle(ddeInst, hszItem);
	}

	DdeFreeStringHandle(ddeInst, hszService);
	DdeFreeStringHandle(ddeInst, hszTopic);
}

void CSampleDlg::OnButton5() 
{
	HSZ	hszService, hszTopic, hszItem;
	HCONV hConv = NULL;
	HDDEDATA hData = NULL;
	DWORD ddeInst = ((CSampleApp *)AfxGetApp())->m_ddeInst;
	CString str;
	int i;

	m_list.ResetContent();
	i = 1;

	hszService = DdeCreateStringHandle(ddeInst, _T("NetAnts"), 0);
	hszTopic = DdeCreateStringHandle(ddeInst, _T("DOWNLOADINFO"), 0);

	hConv = DdeConnect(ddeInst, hszService, hszTopic, NULL);
	if (hConv != NULL) 
	{
		do
		{
			//	LinkItem = Job index to get status infomation
			str.Format(_T("%d"), i);
			hszItem = DdeCreateStringHandle(ddeInst, str, 0);
				
			hData = DdeClientTransaction(NULL, 0, hConv, hszItem, CF_TEXT, XTYP_REQUEST, 500, NULL);
			if (hData != NULL)
			{
				str.Format(_T("%s"), DdeAccessData(hData, NULL));
				m_list.AddString(str);

				DdeUnaccessData(hData);
				DdeFreeDataHandle(hData);
			}

			DdeFreeStringHandle(ddeInst, hszItem);
			i++;
		}while (hData != NULL);

		DdeDisconnect(hConv);
	}

	DdeFreeStringHandle(ddeInst, hszService);
	DdeFreeStringHandle(ddeInst, hszTopic);
}
